"""
******************************
 Mattie EventScripts v1.5.0.000+
  RTB - rio's Team Balancer
      for Counter-Strike: Source

 * Description:
   Team Balancer


 * Install instructions:
       1. Install Mattie's EventScripts plugins:
           http://mattie.info/cs

       2. Copy and upload this script to:
           cstrike/addons/eventscripts/rtb/rtb.py

       3. Add the following line somewhere in autoexec.cfg:
           es_load rtb

 DONT EDIT ANYTHING IN THIS FILE!!

******************************
"""

import es
import playerlib
import keyvalues
import gamethread
import langlib
import os.path

info = es.AddonInfo()
info.name = 'rio\'s Team Balancer'
info.version = '0.1'
info.url = 'http://addons.eventscripts.com/addons/view/rtb'
info.basename = 'rtb'
info.author = 'Rio'

rplayerlist = None
ctkd = 0
tkd = 0
noswitch_counter = 0
rounds = 0
freq = 0

wtcond = {'TS': 0, 'CTS': 0}
teamscores = {'TS': 3, 'CTS': 0}
winstreaks = {'TS': 3, 'CTS': 0}

winnerteam = 0
loserteam = 0

rtb_minrating = 1.5 
rtb_maxrating = 2.0 
rtb_superrating = 3.0 
rtb_maxstreak = 2
rtb_maxscore = 2
rtb_transfer_type = 1
rtb_maxdiff = 2
rtb_switchafter = 4
rtb_switchmin = 4
rtb_switchfreq = 2
rtb_deadonly = 0
rtb_forceswitch = 3
rtb_switchimmunity = 3
rtb_admins = ""

rtb_settings = {'rtb_minrating': '1.5', 'rtb_maxrating': '2.0', 'rtb_superrating': '3.0', 'rtb_maxstreak': '2', 'rtb_maxscore': '2', 'rtb_transfer_type': '1', 'rtb_maxdiff': '2', 'rtb_switchafter': '4', 'rtb_switchmin': '4', 'rtb_switchfreq': '2', 'rtb_deadonly': '0', 'rtb_switchimmunity': '4', 'rtb_forceswitch': '3', 'rtb_admins': ''}

validtargets = {2: {}, 3: {}}
validtargets_count = {2: 0, 3: 0}

text = None

def load():
   global text, rtb_settings, rtb_minrating, rtb_maxrating, rtb_superrating, rtb_maxstreak, rtb_maxscore, rtb_transfer_type, rtb_maxdiff, rtb_switchafter, rtb_switchmin, rtb_switchfreq, rtb_deadonly, rtb_forceswitch, rtb_switchimmunity, rtb_admins 

   for option in rtb_settings:
      es.ServerVar(option, rtb_settings[option], 'RTB')
      
   if os.path.isfile(es.getAddonPath('rtb') + '/rtb_language.ini'):
      text = langlib.Strings(es.getAddonPath("rtb") + "/rtb_language.ini")
   else:
      es.dbgmsg(0, 'RTB: Unable to load rtb_language.cfg! Please ensure it is in the ./rtb/ directory.')
      
   if os.path.isfile(es.getAddonPath('rtb') + '/rtb.cfg'):
      es.server.cmd('es_xmexec ../addons/eventscripts/rtb/rtb.cfg')
   else: 
      es.dbgmsg(0, 'RTB: Unable to load rtb.cfg! Please ensure it is in the ./rtb/ directory.')
      
   rtb_minrating = es.ServerVar('rtb_minrating')
   rtb_maxrating = es.ServerVar('rtb_maxrating')
   rtb_superrating = es.ServerVar('rtb_superrating') 
   rtb_maxstreak = es.ServerVar('rtb_maxstreak')
   rtb_maxscore = es.ServerVar('rtb_maxscore')
   rtb_transfer_type = es.ServerVar('rtb_transfer_type')
   rtb_maxdiff = es.ServerVar('rtb_maxdiff')
   rtb_switchafter = es.ServerVar('rtb_switchafter')
   rtb_switchmin = es.ServerVar('rtb_switchmin')
   rtb_switchfreq = es.ServerVar('rtb_switchfreq')
   rtb_deadonly = es.ServerVar('rtb_deadonly')
   rtb_forceswitch = es.ServerVar('rtb_forceswitch')
   rtb_switchimmunity = es.ServerVar('rtb_switchimmunity')
   rtb_admins = es.ServerVar('rtb_admins')

   es.keygroupcreate('switchimmunity')
   
def unload():
   es.keygroupdelete('switchimmunity')

def round_start(event_var):
   announcement()
   
def round_end(event_var):
   global rplayerlist, teamscores, winstreaks, rtb_switchafter, rounds, freq
   
   switchimmunity = keyvalues.getKeyGroup('switchimmunity')
   for k in switchimmunity:
      round = int(es.keygetvalue('switchimmunity', k.getName(), 'round'))
      round += 1
      
      if round >= rtb_switchimmunity:
         es.keydelete('switchimmunity', k.getName())
      else:
         es.keysetvalue('switchimmunity', k.getName(), 'round', round)
   
   rounds += 1
      
   if int(event_var['winner']) == 2:
      teamscores['TS'] += 1
      
      if winstreaks['TS'] > 0:
         winstreaks['TS'] += 1
      else:
         winstreaks['TS'] = 1
         winstreaks['CTS'] = 0
         
   if int(event_var['winner']) == 3:
      teamscores['CTS'] += 1
      
      if winstreaks['CTS'] > 0:
         winstreaks['CTS'] += 1
      else:
         winstreaks['CTS'] = 1
         winstreaks['TS'] = 0
      
   es.msg('#multi', text('roundended'))  
   rplayerlist = playerlib.getPlayerList('#all')
   
   if es.getplayercount() < rtb_switchmin:
      return
      
   if rounds <= rtb_switchafter or rounds == 1:
      return
      
   freq += 1
   if freq >= rtb_switchfreq:
      freq = 0
   else:
      return
      
   checkteambalance()   
   if int(winnerteam) != 0:
      if rtb_transfer_type < 2 or rtb_transfer_type > 3:
         if es.getplayercount(winnerteam) <= es.getplayercount(loserteam):
            doswitch()
         if es.getplayercount(loserteam) < es.getplayercount(winnerteam):
            dotransfer()
      elif rtb_transfer_type == 2:
         if es.getplayercount(winnerteam) < es.getplayercount(loserteam):
            doswitch()
         if es.getplayercount(loserteam) <= es.getplayercount(winnerteam):
            dotransfer()
      else: 
         if es.getplayercount(winnerteam) + (rtb_maxdiff/2) < es.getplayercount(loserteam):
            doswitch()
         if es.getplayercount(loserteam) <= es.getplayercount(winnerteam) + (rtb_maxdiff/2):
            dotransfer()

def dotransfer():
   global noswitch_counter
   
   if es.getplayercount(winnerteam) == 0:
      es.msg('#multi', text('cantswitch'))
      return
      
   if rtb_deadonly == 1 or noswitch_counter > rtb_forceswitch:
      createvalidtargets(winnerteam, 0)
      if int(validtargets_count[winnerteam]) == 0:
         es.msg('#multi', text('cantswitch_wt'))
         noswitch_counter += 1
         return
   else:
      createvalidtargets(winnerteam, 1)
      if int(validtargets_count[winnerteam]) == 0:
         noswitch_counter += 1
         
         if noswitch_counter > rtb_forceswitch:
            es.msg('#multi', text('cantswitch_dead'))
            dotransfer()
            return
         else:         
            es.msg('#multi', text('cantswitch_wt'))
            return
   
   closestscore = score(winnerteam) - score(loserteam)
   myscore = winner = 0
   for k in validtargets[winnerteam]:
      myscore = score(winnerteam, 0, int(k.userid)) - score(loserteam, int(k.userid), 0)

      if myscore < closestscore and myscore >= 0:
         winner = k.userid
         closestscore = myscore
         
   if int(winner) == 0:
      es.msg('#multi', text('noimprove'))
      return
      
   noswitch_counter = 0
   winnername = es.getplayername(winner)
   
   if winnerteam == 2:
      es.msg('#multi', text('transfer_ct', {'winner': winnername}))
      gamethread.delayed(1.5, es.server.cmd, 'est_team %s 3' % str(winner))
   else:
      es.msg('#multi', text('transfer_t', {'winner': winnername}))
      gamethread.delayed(1.5, es.server.cmd, 'est_team %s 2' % str(winner))
      
   es.keycreate('switchimmunity', winner)
   es.keysetvalue('switchimmunity', winner, 'round', 0)
        
      
def createvalidtargets(team, deadonly):
   global validtargets, validtargets_count
   
   validtargets_count[team] = 0
   validtargets[team] = None
   
   if int(team) == 2:
      validtargets[team] = playerlib.getPlayerList('#t')
   else:
      validtargets[team] = playerlib.getPlayerList('#ct')
             
   for k in validtargets[team]: 
      if es.exists('key', 'switchimmunity', k.userid) == 1:
         validtargets[team].remove(k)
         continue
      
      steamid = str(es.getplayersteamid(k.userid)) + ";"
      if str(steamid) in str(rtb_admins):
         validtargets[team].remove(k)
         continue
         
      if int(k.get('isdead')) == int(deadonly) and int(rtb_deadonly) != 0:
         validtargets[team].remove(k)
         continue
         
   validtargets_count[team] = len(validtargets[team])   
   
def doswitch():
   global noswitch_counter
   
   if es.getplayercount(winnerteam) == 0:
      es.msg('#multi', text('cantswitch'))
      return
      
   if es.getplayercount(winnerteam) == 1:
      es.msg('#multi', text('bestplayer'))
      return
      
   if rtb_deadonly == 1 or noswitch_counter > rtb_forceswitch:
      createvalidtargets(winnerteam, 0)
      createvalidtargets(loserteam, 0)

      if int(validtargets_count[winnerteam]) == 0 or int(validtargets_count[loserteam]) == 0:
         es.msg('#multi', text('cantswitch_wt'))
         noswitch_counter += 1
         return
   else:
      createvalidtargets(winnerteam, 1)
      createvalidtargets(loserteam, 1)
               
      if int(validtargets_count[winnerteam]) == 0 or int(validtargets_count[loserteam]) == 0:
         noswitch_counter += 1
         
         if noswitch_counter > rtb_forceswitch:
            es.msg('#multi', text('cantswitch_dead'))
            dotransfer()
            return
         else:         
            es.msg('#multi', text('cantswitch_wt'))
            return
   
   closestscore = score(winnerteam) - score(loserteam)
   myscore = winner_toloser = winner_towinner = 0
   for k in validtargets[winnerteam]:
      for j in validtargets[loserteam]:
         myscore = score(winnerteam, int(j.userid), int(k.userid)) - score(loserteam, int(k.userid), int(j.userid))
         if myscore < closestscore and myscore >= 0:
            winner_toloser = k.userid
            winner_towinner = j.userid
            closestscore = myscore
         
   if winner_towinner == 0 and winner_toloser == 0:
      es.msg('#multi', text('noimprove'))
      return
      
   noswitch_counter = 0
   winnername_winner = es.getplayername(winner_toloser)
   winnername_loser = es.getplayername(winner_towinner)
   
   es.msg('#multi', text('switch', {'winner': winnername_winner, 'winner2': winnername_loser}))
   gamethread.delayed(1.5, es.server.cmd, 'est_team %s %s; est_team %s %s' % (str(winner_toloser), str(loserteam), str(winner_towinner), str(winnerteam)))
      
   es.keycreate('switchimmunity', winner_towinner)
   es.keysetvalue('switchimmunity', winner_towinner, 'round', 0)
   es.keycreate('switchimmunity', winner_toloser)
   es.keysetvalue('switchimmunity', winner_toloser, 'round', 0)

def fdiv(nom, denom):
   if denom == 0.0:
      return nom
   else:
      return (nom / denom)
   
def score(team, tobeadded=0, toberemoved=0):
   sumkd = 0

   for k in rplayerlist:
      if int(k.attributes['teamid']) != int(team) and int(k) != tobeadded or int(k) == int(toberemoved):
         continue
      
      sumkd += fdiv(float(k.attributes['kills']), float(k.attributes['deaths']))
         
   strength = float(es.getplayercount(team))
   if sumkd > 0:
      strength *= sumkd
         
   return strength
         
   
def checkteambalance():
   global winnerteam, loserteam, wtcond
      
   ctscore = score(3)
   tscore = score(2)
   ctrating = fdiv(ctscore, tscore)
   trating = fdiv(tscore, ctscore)
   
   wtcond = {'TS': 0, 'CTS': 0}
   
   if int(teamscores['TS'] - teamscores['CTS']) > int(rtb_maxscore) and float(trating) >= float(rtb_minrating):
      wtcond['TS'] += 1
   if int(teamscores['CTS'] - teamscores['TS']) > int(rtb_maxscore) and float(ctrating) >= float(rtb_minrating):
      wtcond['CTS'] += 1

   if int(winstreaks['TS']) > int(rtb_maxstreak) and float(trating) >= float(rtb_minrating):
      wtcond['TS'] += 1
   if int(winstreaks['CTS']) > int(rtb_maxstreak) and float(ctrating) >= float(rtb_minrating):
      wtcond['CTS'] += 1

   if float(trating) >= float(rtb_maxrating):
      wtcond['TS'] += 1
   if float(ctrating) >= float(rtb_maxrating):
      wtcond['CTS'] += 1

   if float(trating) >= float(rtb_superrating):
      wtcond['TS'] += 1
   if float(ctrating) >= float(rtb_superrating):
      wtcond['CTS'] += 1

   if es.getplayercount(2) > es.getplayercount(3) and float(trating) >= float(rtb_minrating):
      wtcond['TS'] += 1
   if es.getplayercount(3) > es.getplayercount(2) and float(ctrating) >= float(rtb_minrating):
      wtcond['CTS'] += 1
      
   if wtcond['TS'] >= 2:
      winnerteam = 2
      loserteam = 3
   elif wtcond['CTS'] >= 2:
      winnerteam = 3
      loserteam = 2
   else:
      winnerteam = 0
      loserteam = 0

def announcement():
   if es.getplayercount() < 1:
      return

   checkteambalance()
   
   if winnerteam == 2:
      es.msg('#multi', text('support_ct'))
   elif winnerteam == 3:
      es.msg('#multi', text('support_t'))
   elif wtcond['TS'] > wtcond['CTS']:
      es.msg('#multi', text('advantage_t'))
   elif wtcond['CTS'] > wtcond['TS']:
      es.msg('#multi', text('advantage_ct'))
   else:
      es.msg('#multi', text('teamslookfine'))
      